=== debian/changelog ===
capstone (4.0.2-5) unstable; urgency=medium

  * Team upload.
  * Remove root build requirement
  * Add bindnow hardening flag
  * Bring back hardening patch since dpkg-buildflags puts -DFORTIFY_SOURCE into
    CPPFLAGS

 -- Hilko Bengen <bengen@debian.org>  Sat, 25 Dec 2021 17:44:03 +0100

capstone (4.0.2-4) unstable; urgency=medium

  * Team upload.
  * Add patch to make make build independent of filesystem order
  * Update debian/watch URL
  * Set harding flags via environment variable, drop patch
  * Bump Debhelper compat version

 -- Hilko Bengen <bengen@debian.org>  Sat, 25 Dec 2021 15:08:52 +0100

capstone (4.0.2-3) unstable; urgency=medium

  * Make build verbose (so blhc can inspect the output)
  * Add hardening flags

 -- Hilko Bengen <bengen@debian.org>  Tue, 08 Dec 2020 22:47:42 +0100

capstone (4.0.2-2) unstable; urgency=medium

  * Upload to unstable

 -- Hilko Bengen <bengen@debian.org>  Mon, 07 Dec 2020 21:26:26 +0100

capstone (4.0.2-1) experimental; urgency=medium

  * Team upload.

  [ Hilko Bengen ]
  * New upstream version 4.0.2 (Closes: #921596)
  * Rename library package due to SONAME change
  * Move capstone-tool to utils section (Closes: #960069)
  * Update Python shared library patch

  [ Debian Janitor ]
  * Update standards version to 4.5.0, no changes needed.

 -- Hilko Bengen <bengen@debian.org>  Tue, 19 May 2020 23:39:21 +0200

capstone (4.0.1+really+3.0.5-2) unstable; urgency=medium

  * Team upload.

  [ Samuel Henrique ]
  * Add salsa-ci.yml
  * Configure git-buildpackage for Debian pkg-security-tools

  [ Debian Janitor ]
  * Use secure copyright file specification URI.
  * Use secure URI in Homepage field.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.4.1, no changes needed.

  [ Sandro Tosi ]
  * Drop python2 support; Closes: #936273

  [ Raphaël Hertzog ]
  * Drop non-existing file in debian/copyright
  * Avoid a lintian warning on a duplicate word in the changelog

 -- Raphaël Hertzog <raphael@offensive-security.com>  Fri, 10 Apr 2020 18:30:01 +0200

capstone (4.0.1+really+3.0.5-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop python2 support; Closes: #936273

 -- Sandro Tosi <morph@debian.org>  Thu, 09 Apr 2020 12:51:10 -0400
