=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/" \
    https://github.com/capstone-engine/capstone/releases .*/archive/refs/tags/(4\..*)\.tar\.gz
