## capstone 5.0

=== debian/changelog ===
capstone (5.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 5.0
  * Update watch file
  * Bump Standards-Version
  * Rename lib package due to SONAME bump
  * Update docs file
  * Update patches

 -- Hilko Bengen <bengen@debian.org>  Thu, 06 Jul 2023 16:07:06 +0200
