=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                python3-all-dev,
                python3-setuptools,
                cython3,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Section: devel
 Homepage: https://www.capstone-engine.org/
@@ -18,14 +18,14 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libcapstone4 (= ${binary:Version}), ${misc:Depends}
+Depends: libcapstone5 (= ${binary:Version}), ${misc:Depends}
 Description: lightweight multi-architecture disassembly framework - devel files
  Capstone is a lightweight multi-platform, multi-architecture disassembly
  framework.
  .
  These are the development headers and libraries.
 
-Package: libcapstone4
+Package: libcapstone5
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -65,7 +65,7 @@
 Package: python3-capstone
 Section: python
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, libcapstone4,
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, libcapstone5,
  python3-distutils
 XB-Python3-Version: ${python:Versions}
 Description: lightweight multi-architecture disassembly framework - Python bindings
