## capstone 5.0.3

=== debian/changelog ===
capstone (5.0.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 5.0.3
  * Rebase patches
  * Remove python3-distutils dependency

 -- Hilko Bengen <bengen@debian.org>  Sun, 29 Dec 2024 10:47:28 +0100

capstone (5.0.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 5.0.1

 -- Hilko Bengen <bengen@debian.org>  Wed, 23 Aug 2023 10:19:22 +0200

capstone (4.0.2-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove vestigial distutils.sysconfig import (Closes: #1059671)

 -- Timo Röhling <roehling@debian.org>  Tue, 20 Feb 2024 21:30:13 +0100
